package com.sun.appserver.ee.tests;

import javax.ejb.*;
import javax.naming.*;
import javax.jms.*;
import java.util.*;
import javax.transaction.*;
import com.sun.jts.utils.RecoveryHooks.FailureInducer;
import java.sql.*;
import javax.ejb.EJB;
import javax.annotation.Resource;
import javax.sql.DataSource;



/**
 * This is the bean class for the SimpleTopicLBBean enterprise bean.
 * @author root
 */
public class SimpleTopicLBBean implements javax.ejb.MessageDrivenBean, javax.jms.MessageListener {

    private transient MessageDrivenContext mdc = null;
    private Context context;
    private Context jndiContext = null;
    private TopicConnectionFactory topicConnectionFactory = null;
    private TopicConnection topicConnection = null;
    private TopicSession topicSession = null;
    private Topic topic = null;
    private TopicPublisher topicPublisher = null;

    private java.sql.Connection con = null;
    private java.sql.Statement stmt = null;
    private java.sql.Connection connection=null;
    private java.sql.PreparedStatement pstmt = null;
    private InitialContext initialContext=null;

    
    // <editor-fold defaultstate="collapsed" desc="EJB infrastructure methods. Click on the + sign on the left to edit the code.">
    
    /**
     * @see javax.ejb.MessageDrivenBean#setMessageDrivenContext(javax.ejb.MessageDrivenContext)
     */
    public void setMessageDrivenContext(javax.ejb.MessageDrivenContext aContext) {
        out("In SimpleTopicLBBean.setMessageDrivenContext()");
        mdc = aContext;
    }
    
    public void ejbCreate() throws javax.ejb.CreateException{
        out("In SimpleTopicLBBean.ejbCreate()");
        try{
             
                //create Database connection

	}catch(Exception ex){
            out("Error while creating DB");
            throw new CreateException(ex.getMessage());
	}	

    }
    
    /**
     * @see javax.ejb.MessageDrivenBean#ejbRemove()
     */
    public void ejbRemove() {
    }

    private void createTable(){
        try{
            String createtableStatement = "Create Table MESSAGETABLE (data VARCHAR(100))";
            createConnection();
            stmt = con.createStatement();
            out("Creating the table");

            stmt.executeUpdate(createtableStatement);
        }catch(Exception ex){
            out("create table failed");
            ex.printStackTrace();
        }
    }
    private void dropTable(){
       try{
            createConnection();
            stmt = con.createStatement();
            out("Dropping the table");
            stmt.executeUpdate("drop table messagetable");

        }catch(Exception ex){
            ex.printStackTrace();
        }
    }

      private void createConnection(){
        try{
            if(con==null){
                Class.forName("org.apache.derby.jdbc.ClientDriver");
                con = DriverManager.getConnection("jdbc:derby://localhost:1527/testdb;user=dbuser;password=dbpassword;create=true;");
                stmt = con.createStatement();
                System.out.println("Done DB connection");
            }
        }catch(Exception ex){
            System.out.println("FAILED to create DB connection");
            ex.printStackTrace();
        }

    }

    private void writeMessageToDB(String data){
        try{
            String insertStatement = "insert into messagetable (data) values (?)";
            if (con == null) {
               createConnection();
            }
            pstmt = con.prepareStatement(insertStatement);
            pstmt.setString(1, data);
            pstmt.executeUpdate();
            System.out.println("The messages wrote to the table is " + data);
        }catch(Exception ex){
            System.out.println("failed to write message to DB");
            ex.printStackTrace();
        }finally{
            try{
                pstmt.close();
                pstmt=null;
            }catch(Exception e){
                e.printStackTrace();
            }
        }
    }

    
    // </editor-fold>
    
    public void onMessage(javax.jms.Message aMessage) {
        out("in onMessage.");
        MapMessage mapMsg = null;
        Integer count =0;
        String instanceid = null; 
        try{    
                System.out.println("begin read message.");
                mapMsg = (MapMessage)aMessage;
                Enumeration enums = mapMsg.getMapNames();
                String name = null;
                String value = null;
                while(enums.hasMoreElements()){
                    name = (String)enums.nextElement();
                    value = (String)mapMsg.getObject(name);
                    System.out.println("Message received " + name+"="+value);
                    instanceid = System.getProperty("com.sun.genericra.loadbalancing.instance.id");
                    System.out.println("Instance " + instanceid +" processed message " + name+"="+value); 
                    //Write messages to Database
                }
                System.out.println("End read messages");
        }catch(Exception ex){
            ex.printStackTrace();
        }  
        
    }
    
    private void out(String message){
        System.out.println("MDB " + message);
    }
}
